﻿using System.Diagnostics.CodeAnalysis;

namespace ProjectCleaningCar.Drawning;

/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawningTruckEqutables : IEqualityComparer<DrawningTruck?>
{
    public bool Equals(DrawningTruck? x, DrawningTruck? y)
    {
        if (x == null || x.EntityTruck == null)
        {
            return false;
        }
        if (y == null || y.EntityTruck == null)
        {
            return false;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }
        if (x.EntityTruck.Speed != y.EntityTruck.Speed)
        {
            return false;
        }
        if (x.EntityTruck.Weight != y.EntityTruck.Weight)
        {
            return false;
        }
        if (x.EntityTruck.BodyColor != y.EntityTruck.BodyColor)
        {
            return false;
        }
        if (x is DrawningCleaningCar && y is DrawningCleaningCar)
        {
            // TODO доделать логику сравнения дополнительных параметров
        }
        return true;
    }

    public int GetHashCode([DisallowNull] DrawningTruck obj)
    {
        return obj.GetHashCode();
    }
}